#ifndef EDITOR_H
#define EDITOR_H

#include "term.h"

class TTermEditor: public TTree<TTerm>
{
public:
						 TTermEditor();
	BOOL       		 ReadSubtreeFromStream(istream& is, TNodeAddress& addr);
	BOOL		 		 ReadFromStream(istream& is);
	inline void		 WriteSubtreeToStream(ostream& os, TNodeAddress& addr);
	inline void		 WriteToStream(ostream& os);

	void    			 Refine(TNodeAddress& address, Operator op);
	void    			 Delete(TNodeAddress& address);
	void    			 ListInsert(TNodeAddress& address, int childnumber);
	void    			 ListDelete(TNodeAddress& address, int childnumber);

private:
	BOOL       		 ReadSubtreeFromStream(istream& is, TTerm *parent, int cn);
	void				 InsertHole(TTerm *parent, int cn);
	void				 InsertOperator(TTerm *parent, int cn, Operator op);
};


inline void TTermEditor::WriteSubtreeToStream(ostream& os, TNodeAddress& addr)
{
	os << NodeAt(addr);
}

inline void TTermEditor::WriteToStream(ostream& os)
{
	if(GetRoot())
		os << GetRoot();
}
#endif

