/*  Project WinStruc
    Copyright 1995 Hugo Lyppens

*/


#include "owlhdr.h"
#pragma hdrstop

#include "main.rc"            // Definition of all resources.


class WinStrucApp : public TApplication {
private:

public:
	WinStrucApp ();
	virtual ~WinStrucApp ();

	TMDIClient  *mdiClient;

//{{WinStrucAppVIRTUAL_BEGIN}}
public:
	virtual void InitMainWindow();

protected:
	void EvNewView (TView& view);
	void EvCloseView (TView& view);
	DECLARE_RESPONSE_TABLE(WinStrucApp);
};




//#include "rndabtdl.h"                        // Definition of about dialog.


DEFINE_RESPONSE_TABLE1(WinStrucApp, TApplication)
	 EV_OWLVIEW(dnCreate, EvNewView),
	 EV_OWLVIEW(dnClose,  EvCloseView),
//	 EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
END_RESPONSE_TABLE;


WinStrucApp::WinStrucApp () : TApplication("Multi-View Structure Editor")
{

	 DocManager = new TDocManager(dmMDI | dmMenu);

	 // INSERT>> Your constructor code here.

}


WinStrucApp::~WinStrucApp ()
{
	 // INSERT>> Your destructor code here.

}


void WinStrucApp::InitMainWindow ()
{
	 mdiClient = new TMDIClient;
	 TDecoratedMDIFrame* frame = new TDecoratedMDIFrame(Name, MDI_MENU, *mdiClient, TRUE);

	 nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

	 //
	 // Assign ICON w/ this application.
	 //
	 frame->SetIcon(this, IDI_MDIAPPLICATION);

	 //
	 // Menu associated with window and accelerator table associated with table.
	 //
	 frame->AssignMenu(MDI_MENU);

	 //
	 // Associate with the accelerator table.
	 //
//	 frame->Attr.AccelTable = MDI_MENU;



	 TStatusBar *sb = new TStatusBar(frame, TGadget::Recessed,
												TStatusBar::CapsLock        |
												TStatusBar::NumLock         |
												TStatusBar::ScrollLock      |
												TStatusBar::Overtype);
	 frame->Insert(*sb, TDecoratedFrame::Bottom);

	 SetMainWindow(frame);

}


//////////////////////////////////////////////////////////
// WinStrucApp
// =====
// Response Table handlers:
//
void WinStrucApp::EvNewView (TView& view)
{
	 TMDIClient *mdiClient = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TMDIClient);
	 if (mdiClient) {
		  TMDIChild* child = new TMDIChild(*mdiClient, 0, view.GetWindow());

		  child->SetIcon(this, IDI_DOC);

		  child->Create();
	 }
}


void WinStrucApp::EvCloseView (TView&)
{
}


//////////////////////////////////////////////////////////
// WinStrucApp
// ===========
// Menu Help About WinStruc.exe command
#if 0
void WinStrucApp::CmHelpAbout ()
{
	 //
	 // Show the modal dialog.
	 //
	 WinStrucAboutDlg(MainWindow).Execute();
}
#endif

int OwlMain (int , char* [])
{
	 WinStrucApp     App;
	 int             result;

	 result = App.Run();

	 return result;
}

