//----------------------------------------------------------------------------
//    Copyright 1995 Hugo Lyppens
//   	Implements class TMyDC
//----------------------------------------------------------------------------
#include "owlhdr.h"
#pragma hdrstop
#include "mydc.h"


static const TBrush brush(RGB(255, 255, 0));

void TMyDC::Plus(TPoint& pos)
{
   const int   PlusA = (PlusSize-4)/2;
//   TBrush      brush(PlusColor);
   if(GetClipBox().Touches(TRect(pos, TSize(PlusSize, PlusSize)))) {
      SelectObject(brush);
      Rectangle(pos.x+PlusA, pos.y, pos.x+(PlusA+3), pos.y+PlusSize-1);
      Rectangle(pos.x, pos.y+PlusA, pos.x+PlusSize-1, pos.y+(PlusA+3));
      FillRect(pos.x+PlusA+1, pos.y+PlusA, pos.x+PlusA+2, pos.y+PlusA+3, brush);
      RestoreBrush();
   }
}
void TMyDC::Arrow(TPoint& pos, enum Direction dir)
{
   TPoint   triangle[3];
   TRect    br;

   triangle[0] = pos;
   switch(dir) {
   case UP:
      br.Set(pos.x-ArrowWidth/2,pos.y,pos.x+ArrowWidth/2, pos.y+ArrowLength);
      triangle[1].x = pos.x+ArrowWidth/2; triangle[1].y = pos.y+ArrowLength;
      triangle[2].x = pos.x-ArrowWidth/2; triangle[2].y = pos.y+ArrowLength;
      break;
   case DOWN:
      br.Set(pos.x-ArrowWidth/2,pos.y-ArrowLength,pos.x+ArrowWidth/2, pos.y);
      triangle[1].x = pos.x-ArrowWidth/2; triangle[1].y = pos.y-ArrowLength;
      triangle[2].x = pos.x+ArrowWidth/2; triangle[2].y = pos.y-ArrowLength;
      break;
   case LEFT:
      br.Set(pos.x, pos.y-ArrowWidth/2,pos.x+ArrowLength,pos.y+ArrowWidth/2);
      triangle[1].x = pos.x+ArrowLength;  triangle[1].y = pos.y-ArrowWidth/2;
      triangle[2].x = pos.x+ArrowLength;  triangle[2].y = pos.y+ArrowWidth/2;
      break;
   case RIGHT:
      br.Set(pos.x-ArrowLength, pos.y-ArrowWidth/2,pos.x,pos.y+ArrowWidth/2);
      triangle[1].x = pos.x-ArrowLength;  triangle[1].y = pos.y+ArrowWidth/2;
      triangle[2].x = pos.x-ArrowLength;  triangle[2].y = pos.y-ArrowWidth/2;
   }
//   TBrush brush(arrowcolor);
   if(GetClipBox().Touches(br)) {
      SelectObject(brush);
      Polygon(triangle, 3);
      RestoreBrush();
   }
}


void TMyDC::ShadowRectangle(TRect& rect, TBrush& fill, TPen& pen, TBrush& shadow,
									 TSize& shadowbottleft, TSize& shadowtopright)
{
	SelectObject(pen);
	SelectObject(fill);
	Rectangle(rect);
	FillRect(rect.left+shadowbottleft.cx, rect.bottom,
				rect.right+shadowtopright.cx, rect.bottom+shadowbottleft.cy, shadow);
	FillRect(rect.right, rect.top+shadowtopright.cy,
				rect.right+shadowtopright.cx, rect.bottom, shadow);
	RestoreBrush(); RestorePen();
}

void TMyDC::RectangleOutline(TRect& rect)
{
	MoveTo(rect.TopLeft());
	LineTo(rect.right-1, rect.top);
	LineTo(rect.right-1, rect.bottom-1);
	LineTo(rect.left,    rect.bottom-1);
	LineTo(rect.TopLeft());
}

