//----------------------------------------------------------------------------
//    Copyright 1995 Hugo Lyppens
//   	Implements class TScrolledWindowView
//----------------------------------------------------------------------------
#include "owlhdr.h"
#pragma hdrstop

#include "scrwview.h"

const long& max(const long&, const long&);

DEFINE_RESPONSE_TABLE1(TScrolledWindowView, TWindowView)
	EV_WM_SIZE,
END_RESPONSE_TABLE;

TScrolledWindowView::TScrolledWindowView(TDocument& doc, TWindow *parent):
               TWindowView(doc, parent)
{
   Attr.Style     |= WS_VSCROLL | WS_HSCROLL;
   Scroller = new TScroller(this, 1, 1, 200, 200);
}

void
TScrolledWindowView::AdjustScroller()
{
   TRect           clientrect;
   GetClientRect(clientrect);

   TSize           sizediff = CalcSize()-clientrect.Size();

  // only show scrollbars when image is larger than
  // the client area
  //
	Scroller->SetRange(max(sizediff.cx, 0), max(sizediff.cy, 0));
   if (!GetUpdateRect(clientrect, FALSE))
     Invalidate(FALSE);
}

void TScrolledWindowView::EvSize(UINT SizeType, TSize& Size)
{
   TWindow::EvSize(SizeType, Size);
   if (SizeType != SIZEICONIC) {
      AdjustScroller();
      Invalidate(FALSE);
   }
}
