enum Operator {
	OP_NONE,
/* HOLES */
	OP_PROGHOLE, OP_DECHOLE, OP_NDECHOLE, OP_DECSHOLE,
	OP_IDHOLE,	 OP_TYPEHOLE, OP_STATHOLE, OP_STATSHOLE, OP_VARSHOLE, OP_EXPRSHOLE,OP_EXPRHOLE,
	OP_ALTS1HOLE,OP_ALTS2HOLE, OP_ALT2HOLE, OP_LABELSHOLE, OP_LABELHOLE,
	OP_PBODYHOLE,OP_PPARSHOLE,
	OP_PPARHOLE, OP_PARGSHOLE, OP_PARGHOLE, OP_FBODYHOLE, OP_FPARSHOLE,
	OP_FPARHOLE, OP_FARGSHOLE,
/* Real operators */
	OP_PROG, OP_DECS, OP_NDECS, OP_NDEC, OP_PROCDEC, OP_FUNCDEC,
	OP_ID, OP_INTTYPE, OP_BOOLTYPE, OP_CHARTYPE,	OP_REALTYPE,	OP_STATS, OP_SKIP,
	OP_CONCASSIGN, OP_PROCCALL, OP_PROCCALLARGS, OP_IFTHEN, OP_IFTHENELSE,
	OP_WHILE, OP_READ, OP_WRITE, OP_FOR, OP_BLOCK, OP_VARS, OP_EXPRS,
	OP_VARVALUE, OP_FUNCCALL, OP_FUNCCALLARGS, OP_NUMVALUE, OP_CHARVALUE,
	OP_IMPLICATION, OP_EQUIVALENCE, OP_OR,  OP_AND,  OP_LESS,  OP_LESSEQ,
	OP_GREATER,  OP_GREATEREQ, OP_EQUALITY, OP_DIFFERENCE, OP_ADDITION,
	OP_SUBTRACTION, OP_MULTIPLICATION, OP_DIVISION, OP_MODULO,
	OP_UNARYMINUS, OP_NOT, OP_EXPRBLOCK, OP_PBODYSTATS, OP_PBODYPARSSTATS,
	OP_PPARS, OP_PPARVALUE, OP_PPARREF, OP_PARGS, OP_PARGVALUE, OP_PARGREF,
	OP_FBODY, OP_FPARS, OP_FPARVALUE, OP_FARGS,
	OP_NUMCASE, OP_LABCASE, OP_ALTS1, OP_ALTS2, OP_ALT2, OP_LABELS,
	OP_CHARLABEL, OP_NUMLABEL
};


DEFINE_SORT_AND_HOLE(PROG)
DEFINE_SORT_AND_HOLE(DEC)
DEFINE_SORT_AND_HOLE(NDEC)
DEFINE_SORT_AND_HOLE(DECS)
DEFINE_SORT_AND_HOLE(ID)
DEFINE_SORT_AND_HOLE(TYPE)
DEFINE_SORT_AND_HOLE(STAT)
DEFINE_SORT_AND_HOLE(STATS)
DEFINE_SORT_AND_HOLE(VARS)
DEFINE_SORT_AND_HOLE(EXPRS)
DEFINE_SORT_AND_HOLE(EXPR)
DEFINE_SORT_AND_HOLE(ALTS1)
DEFINE_SORT_AND_HOLE(ALTS2)
DEFINE_SORT_AND_HOLE(ALT2)
DEFINE_SORT_AND_HOLE(LABELS)
DEFINE_SORT_AND_HOLE(LABEL)
DEFINE_SORT_AND_HOLE(PBODY)
DEFINE_SORT_AND_HOLE(PPARS)
DEFINE_SORT_AND_HOLE(PPAR)
DEFINE_SORT_AND_HOLE(PARGS)
DEFINE_SORT_AND_HOLE(PARG)
DEFINE_SORT_AND_HOLE(FBODY)
DEFINE_SORT_AND_HOLE(FPARS)
DEFINE_SORT_AND_HOLE(FPAR)
DEFINE_SORT_AND_HOLE(FARGS)
DEFINE_OP2(PROG, 				PROG, 	Declarations, DECS, Statements, STATS)
DEFINE_OP_LIST(DECS, 		DECS,		Declaration, DEC)
DEFINE_OP_LIST(NDECS, 		DEC,		VarDeclaration, NDEC)
DEFINE_OP2(NDEC,				NDEC,		Variable, ID, Type, TYPE)
DEFINE_OP2(PROCDEC,			DEC,		ProcName, ID, Body, PBODY)
DEFINE_OP2(FUNCDEC,			DEC,		FuncName, ID, Body, FBODY)
DEFINE_OP0(ID,					ID)
DEFINE_OP0(INTTYPE, 			TYPE)
DEFINE_OP0(BOOLTYPE,			TYPE)
DEFINE_OP0(CHARTYPE,			TYPE)
DEFINE_OP0(REALTYPE,			TYPE)
DEFINE_OP_LIST(STATS,		STATS,	Statement, STAT)
DEFINE_OP0(SKIP,				STAT)
DEFINE_OP2(CONCASSIGN,		STAT,		Variables, VARS, Expressions, EXPRS)
DEFINE_OP1(PROCCALL,			STAT,		ProcName, ID)
DEFINE_OP2(PROCCALLARGS,	STAT,		ProcName, ID, Arguments, PARGS)
DEFINE_OP2(IFTHEN,			STAT,		Guard, EXPR, TrueStatements, STATS)
DEFINE_OP3(IFTHENELSE,		STAT,		Guard, EXPR, TrueStatements, STATS, FalseStatements, STATS)
DEFINE_OP2(WHILE,				STAT,		Guard, EXPR, Statements, STATS)
/*DEFINE_OP3(		45, NUMCASE,			STAT,		Expression, EXPR, Alternatives, ALTS1, OutStatements, STATS)
DEFINE_OP3(		46, LABCASE,			STAT,		Expression, EXPR, LabAlternatives, ALTS2, OutStatements, STATS)*/
DEFINE_OP_LIST(READ,			STAT,		Variable, ID)
DEFINE_OP_LIST(WRITE,		STAT,		Expression, EXPR)
DEFINE_OP5(FOR,				STAT,		Variable, ID, FromExpression, EXPR, ByExpression, EXPR, ToExpression, EXPR, Statements, STATS)
DEFINE_OP2(BLOCK,				STAT,		Declarations, DECS, Statements, STATS)
DEFINE_OP_LIST(VARS,			VARS,		Variable, ID)
DEFINE_OP_LIST(EXPRS,		EXPRS,	Expression, EXPR)
DEFINE_OP1(VARVALUE,			EXPR,		Variable, ID)
DEFINE_OP1(FUNCCALL,			EXPR,		FuncName, ID)
DEFINE_OP2(FUNCCALLARGS,	EXPR,		FuncName, ID, Arguments, FARGS)
DEFINE_OP0(NUMVALUE,			EXPR)
DEFINE_OP0(CHARVALUE,		EXPR)
DEFINE_OP2(IMPLICATION,		EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(EQUIVALENCE,		EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(OR,					EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(AND,				EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(LESS,				EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(LESSEQ,			EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(GREATER,			EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(GREATEREQ,		EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(EQUALITY,			EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(DIFFERENCE,		EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(ADDITION,			EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(SUBTRACTION, 	EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(MULTIPLICATION,	EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(DIVISION,			EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP2(MODULO,			EXPR,		Arg0, EXPR, Arg1, EXPR)
DEFINE_OP1(UNARYMINUS,		EXPR,		Arg0, EXPR)
DEFINE_OP1(NOT,				EXPR,		Arg0, EXPR)
DEFINE_OP3(EXPRBLOCK,		EXPR,		Declarations, DECS, Statements, STATS, Expression, EXPR)
DEFINE_OP_LIST(PBODYSTATS,	PBODY,	Statement, STAT)
DEFINE_OP2(PBODYPARSSTATS,	PBODY,	ProcParameters, PPARS, Statements, STATS)
DEFINE_OP_LIST(PPARS,		PPARS,	ProcParameter, PPAR)
DEFINE_OP2(PPARVALUE,		PPAR,		Variable, ID, Type, TYPE)
DEFINE_OP2(PPARREF,		 	PPAR,		Variable, ID, Type, TYPE)
DEFINE_OP_LIST(PARGS,		PARGS,	ProcArgument, PARG)
DEFINE_OP1(PARGVALUE,		PARG,		Expression, EXPR)
DEFINE_OP1(PARGREF,		 	PARG,		Variable, ID)
DEFINE_OP2(FBODY,				FBODY,	FuncParameters, FPARS, Expression, EXPR)
DEFINE_OP_LIST(FPARS,		FPARS,	FuncParameter, FPAR)
DEFINE_OP2(FPARVALUE,		FPAR,		Variable, ID, Type, TYPE)
DEFINE_OP_LIST(FARGS,		FARGS,	FuncArgument, EXPR)
DEFINE_OP3(NUMCASE, 			STAT,		Case, EXPR, In, ALTS1, Out, STATS)
DEFINE_OP3(LABCASE, 			STAT,		Case, EXPR, In, ALTS2, Out, STATS)
DEFINE_OP_LIST(ALTS1, 		ALTS1,	Statements, STATS)
DEFINE_OP_LIST(ALTS2,		ALTS2,	Alternative, ALT2)
DEFINE_OP2(ALT2,				ALT2,		Labels, LABELS, Statements, STATS)
DEFINE_OP_LIST(LABELS,		LABELS,	Label, LABEL)
DEFINE_OP0(NUMLABEL, 		LABEL)
DEFINE_OP0(CHARLABEL, 		LABEL)

const Operator OP_FIRSTHOLE = OP_PROGHOLE;
const Operator OP_LASTHOLE  = OP_FARGSHOLE;
const Operator OP_FIRST     = OP_PROG;
const Operator OP_LAST      = OP_CHARLABEL;

const Sort     TERMSORT		 = SORT_PROG;

template<class T>
T              *CreateOperatorNode(T *,const Operator op)
{
	T              *node = 0;

	switch(op) {
	case OP_PROGHOLE: 		node = new TPROGHOLE<T>; break;
	case OP_DECHOLE:			node = new TDECHOLE<T>; break;
	case OP_NDECHOLE:			node = new TNDECHOLE<T>; break;
	case OP_DECSHOLE:			node = new TDECSHOLE<T>; break;
	case OP_IDHOLE:			node = new TIDHOLE<T>; break;
	case OP_TYPEHOLE:			node = new TTYPEHOLE<T>; break;
	case OP_STATHOLE:			node = new TSTATHOLE<T>; break;
	case OP_STATSHOLE:		node = new TSTATSHOLE<T>; break;
	case OP_VARSHOLE:			node = new TVARSHOLE<T>; break;
	case OP_EXPRSHOLE:		node = new TEXPRSHOLE<T>; break;
	case OP_EXPRHOLE:			node = new TEXPRHOLE<T>; break;
	case OP_ALTS1HOLE:		node = new TALTS1HOLE<T>; break;
	case OP_ALTS2HOLE:		node = new TALTS2HOLE<T>; break;
	case OP_ALT2HOLE:			node = new TALT2HOLE<T>; break;
	case OP_LABELSHOLE:		node = new TLABELSHOLE<T>; break;
	case OP_LABELHOLE:		node = new TLABELHOLE<T>; break;
	case OP_PBODYHOLE:		node = new TPBODYHOLE<T>; break;
	case OP_PPARSHOLE:		node = new TPPARSHOLE<T>; break;
	case OP_PPARHOLE:			node = new TPPARHOLE<T>; break;
	case OP_PARGSHOLE:		node = new TPARGSHOLE<T>; break;
	case OP_PARGHOLE:			node = new TPARGHOLE<T>; break;
	case OP_FBODYHOLE:		node = new TFBODYHOLE<T>; break;
	case OP_FPARSHOLE:		node = new TFPARSHOLE<T>; break;
	case OP_FPARHOLE:			node = new TFPARHOLE<T>; break;
	case OP_FARGSHOLE:		node = new TFARGSHOLE<T>; break;

	case OP_PROG:				node = new TPROG<T>; break;
	case OP_BLOCK:				node = new TBLOCK<T>; break;
	case OP_DECS:				node = new TDECS<T>; break;
	case OP_NDECS:				node = new TNDECS<T>; break;
	case OP_NDEC:				node = new TNDEC<T>; break;
	case OP_PROCDEC:			node = new TPROCDEC<T>; break;
	case OP_FUNCDEC:			node = new TFUNCDEC<T>; break;
	case OP_ID:					node = new TID<T>; break;
	case OP_INTTYPE:			node = new TINTTYPE<T>; break;
	case OP_BOOLTYPE:			node = new TBOOLTYPE<T>; break;
	case OP_CHARTYPE:			node = new TCHARTYPE<T>; break;
	case OP_REALTYPE:			node = new TREALTYPE<T>; break;
	case OP_STATS:				node = new TSTATS<T>; break;
	case OP_SKIP:				node = new TSKIP<T>; break;
	case OP_CONCASSIGN:		node = new TCONCASSIGN<T>; break;
	case OP_PROCCALL:			node = new TPROCCALL<T>; break;
	case OP_PROCCALLARGS:	node = new TPROCCALLARGS<T>; break;
	case OP_IFTHEN:			node = new TIFTHEN<T>; break;
	case OP_IFTHENELSE:		node = new TIFTHENELSE<T>; break;
	case OP_WHILE:				node = new TWHILE<T>; break;
	case OP_READ:				node = new TREAD<T>; break;
	case OP_WRITE:				node = new TWRITE<T>; break;
	case OP_FOR:				node = new TFOR<T>; break;
	case OP_VARS:				node = new TVARS<T>; break;
	case OP_EXPRS:				node = new TEXPRS<T>; break;
	case OP_VARVALUE:			node = new TVARVALUE<T>; break;
	case OP_FUNCCALL:			node = new TFUNCCALL<T>; break;
	case OP_FUNCCALLARGS:	node = new TFUNCCALLARGS<T>; break;
	case OP_NUMVALUE:			node = new TNUMVALUE<T>; break;
	case OP_CHARVALUE:		node = new TCHARVALUE<T>; break;
	case OP_IMPLICATION:		node = new TIMPLICATION<T>; break;
	case OP_EQUIVALENCE:		node = new TEQUIVALENCE<T>; break;
	case OP_OR:					node = new TOR<T>; break;
	case OP_AND:				node = new TAND<T>; break;
	case OP_LESS:				node = new TLESS<T>; break;
	case OP_LESSEQ:			node = new TLESSEQ<T>; break;
	case OP_GREATER:			node = new TGREATER<T>; break;
	case OP_GREATEREQ:		node = new TGREATEREQ<T>; break;
	case OP_EQUALITY:			node = new TEQUALITY<T>; break;
	case OP_DIFFERENCE:		node = new TDIFFERENCE<T>; break;
	case OP_ADDITION:			node = new TADDITION<T>; break;
	case OP_SUBTRACTION:		node = new TSUBTRACTION<T>; break;
	case OP_MULTIPLICATION:	node = new TMULTIPLICATION<T>; break;
	case OP_DIVISION:			node = new TDIVISION<T>; break;
	case OP_MODULO:			node = new TMODULO<T>; break;
	case OP_UNARYMINUS:		node = new TUNARYMINUS<T>; break;
	case OP_NOT:				node = new TNOT<T>; break;
	case OP_EXPRBLOCK:		node = new TEXPRBLOCK<T>; break;
	case OP_PBODYSTATS:		node = new TPBODYSTATS<T>; break;
	case OP_PBODYPARSSTATS:	node = new TPBODYPARSSTATS<T>; break;
	case OP_PPARS:				node = new TPPARS<T>; break;
	case OP_PPARVALUE:		node = new TPPARVALUE<T>; break;
	case OP_PPARREF:			node = new TPPARREF<T>; break;
	case OP_PARGS:				node = new TPARGS<T>; break;
	case OP_PARGVALUE:		node = new TPARGVALUE<T>; break;
	case OP_PARGREF:			node = new TPARGREF<T>; break;
	case OP_FBODY:				node = new TFBODY<T>; break;
	case OP_FPARS:				node = new TFPARS<T>; break;
	case OP_FPARVALUE:		node = new TFPARVALUE<T>; break;
	case OP_FARGS:				node = new TFARGS<T>; break;
	case OP_NUMCASE:			node = new TNUMCASE<T>; break;
	case OP_LABCASE:			node = new TLABCASE<T>; break;
	case OP_ALTS1:				node = new TALTS1<T>; break;
	case OP_ALTS2:				node = new TALTS2<T>; break;
	case OP_ALT2:				node = new TALT2<T>; break;
	case OP_LABELS:			node = new TLABELS<T>; break;
	case OP_CHARLABEL:		node = new TCHARLABEL<T>; break;
	case OP_NUMLABEL:			node = new TNUMLABEL<T>; break;
	}
	return node;
}

