#ifndef STRUCDOC_H
#define STRUCDOC_H

#include "editor.h"

class  _DOCVIEWCLASS TStructDocument : public TFileDocument
{
public:
	 TStructDocument(TDocument* parent = 0);

	 // implement virtual methods of TDocument
	 BOOL   			 Open(int mode, const char far* path=0);
//	 BOOL  			 IsOpen() { return FALSE; }
	 BOOL  			 Commit(BOOL force = FALSE);
	 BOOL  			 Revert(BOOL clear = FALSE);

	 // data access functions
	void    			 Refine(TNodeAddress& address, Operator op, TWindow *window = 0);
	void    			 Delete(TNodeAddress& address);
	void    			 Cut(TNodeAddress& address, HWND);
	void    			 Copy(TNodeAddress& address, HWND);
	void    			 Paste(TNodeAddress& address, HWND);
	void    			 ListInsert(TNodeAddress& address, int childnumber);
	void    			 ListDelete(TNodeAddress& address, int childnumber);
	void    			 GlobalFocus(TNodeAddress& address);

	BOOL				 ClipboardOK(const Sort sort, HWND hwnd) const;
	TTree<TTerm>	*GetTree() {return &Editor;}

	void				 GetActiveAddress(TNodeAddress& address) const;
	void				 SetActiveAddress(TNodeAddress& address);
private:
	TTerm				*ActiveNode;
	TTermEditor		 Editor;
	static UINT     ClipboardFormat;
};



//////////////////////////////////////
const int vnMirrorSubtree = vnCustomBase+0;
const int vnGlobalFocus   = vnCustomBase+1;
const int vnNewActive	  = vnCustomBase+2;

#endif

