//----------------------------------------------------------------------------
//    Copyright 1995 Hugo Lyppens
//   	Implements class TTerm
//----------------------------------------------------------------------------
#include "owlhdr.h"
#pragma hdrstop
#include "term.h"



int              TTerm::GetTermLength()
{
	 int     nc = GetNumChildren();
	 int     tl = strlen(GetOpName())+(nc?nc+1:0);
	 if(GetData())
	 	tl += 2+strlen((char *)GetData());

	 for(int i = 0; i<nc; i++) {
		  tl+=GetChild(i)->GetTermLength();
	 }
	 return tl;
}

ostream&         operator<<(ostream& s, TTerm *term)
{
	 int     nc = term->GetNumChildren();

	 s << GetOpName(term->GetOperator());
	 if(term->GetData())
		s << '{' << (char *)(term->GetData()) << '}';
	 if(nc) {
		  s << '[';
		  for(int i = 0; i<nc; i++) {
				s << term->GetChild(i);
				if(i!=nc-1)
					 s << ',';
		  }
		  s << ']';
	 }
	 return s;
}

TTerm::~TTerm()
{
	if(Data)
		free(Data);
}

void TTerm::SetData(void *d, int length)
{
	if(Data)
		free(Data);
	Data = 0; Length = 0;
	if(d && length) {
		Data = malloc(length); Length = length;
		memcpy(Data, d, length);
	}
}

