#ifndef TERM_H
#define TERM_H

#include "tree.h"
#include "mydc.h"

typedef unsigned Sort;
const Sort SORT_NONE = 0;


#define DEFINE_OP0(name, rsort)  \
template<class T> \
class		T##name:	 public TSort##rsort<T> { \
public: \
	Operator 				GetOperator() { return OP_##name; } \
	void                 Draw(TMyDC&, TPoint&); \
	void                 CalcSize(TMyDC&); \
\
								T##name(); \
};\
template<class T> \
								T##name<T>::T##name(): TSort##rsort<T>(0, TRUE) {}


#define DEFINE_OP1(name, rsort, a0name, a0sort)  \
template<class T> \
class		T##name:	 public TSort##rsort<T> { \
public: \
	Operator 				GetOperator() { return OP_##name; } \
	void                 Draw(TMyDC&, TPoint&); \
	void                 CalcSize(TMyDC&); \
\
	TSort##a0sort<T>*    Get##a0name()  { return (TSort##a0sort<T>*)GetChild(0); } \
	Sort                 GetDesiredChildSort(int n); \
	int                  GetDesiredNumChildren() { return 1; } \
\
								T##name(); \
}; \
template<class T> \
								T##name<T>::T##name(): TSort##rsort<T>(1, TRUE) {} \
\
template<class T> \
Sort              T##name<T>::GetDesiredChildSort(int n) \
{ \
	switch(n) { case 0:  return SORT_##a0sort; \
					default: return SORT_NONE; \
	} \
}



#define DEFINE_OP2(name, rsort, a0name, a0sort, a1name, a1sort)  \
template<class T> \
class		T##name:	 public TSort##rsort<T> { \
public: \
	Operator 				GetOperator() { return OP_##name; } \
	void                 Draw(TMyDC&, TPoint&); \
	void                 CalcSize(TMyDC&); \
\
	TSort##a0sort<T>*    Get##a0name()  { return (TSort##a0sort<T>*)GetChild(0); } \
	TSort##a1sort<T>*    Get##a1name()  { return (TSort##a1sort<T>*)GetChild(1); } \
	Sort                 GetDesiredChildSort(int n); \
	int                  GetDesiredNumChildren() { return 2; } \
\
								T##name(); \
}; \
template<class T> \
								T##name<T>::T##name(): TSort##rsort<T>(2, TRUE) {} \
\
template<class T> \
Sort              T##name<T>::GetDesiredChildSort(int n) \
{ \
	switch(n) { case 0:  return SORT_##a0sort; \
					case 1:  return SORT_##a1sort; \
					default: return SORT_NONE; \
	} \
}



#define DEFINE_OP3(name, rsort, a0name, a0sort, a1name, a1sort, a2name, a2sort)  \
template<class T> \
class		T##name:	 public TSort##rsort<T> { \
public: \
	Operator 				GetOperator() { return OP_##name; } \
	void                 Draw(TMyDC&, TPoint&); \
	void                 CalcSize(TMyDC&); \
\
	TSort##a0sort<T>*    Get##a0name()  { return (TSort##a0sort<T>*)GetChild(0); } \
	TSort##a1sort<T>*    Get##a1name()  { return (TSort##a1sort<T>*)GetChild(1); } \
	TSort##a2sort<T>*    Get##a2name()  { return (TSort##a2sort<T>*)GetChild(2); } \
	Sort                 GetDesiredChildSort(int n); \
	int                  GetDesiredNumChildren() { return 3; } \
\
								T##name(); \
}; \
template<class T> \
								T##name<T>::T##name(): TSort##rsort<T>(3, TRUE) {} \
\
template<class T> \
Sort              T##name<T>::GetDesiredChildSort(int n) \
{ \
	switch(n) { case 0:  return SORT_##a0sort; \
					case 1:  return SORT_##a1sort; \
					case 2:  return SORT_##a2sort; \
					default: return SORT_NONE; \
	} \
}



#define DEFINE_OP4(name, rsort, a0name, a0sort, a1name, a1sort, a2name, a2sort, a3name, a3sort)  \
template<class T> \
class		T##name:	 public TSort##rsort<T> { \
public: \
	Operator 				GetOperator() { return OP_##name; } \
	void                 Draw(TMyDC&, TPoint&); \
	void                 CalcSize(TMyDC&); \
\
	TSort##a0sort<T>*    Get##a0name()  { return (TSort##a0sort<T>*)GetChild(0); } \
	TSort##a1sort<T>*    Get##a1name()  { return (TSort##a1sort<T>*)GetChild(1); } \
	TSort##a2sort<T>*    Get##a2name()  { return (TSort##a2sort<T>*)GetChild(2); } \
	TSort##a3sort<T>*    Get##a3name()  { return (TSort##a3sort<T>*)GetChild(3); } \
	Sort                 GetDesiredChildSort(int n); \
	int                  GetDesiredNumChildren() { return 4; } \
\
								T##name(); \
}; \
template<class T> \
								T##name<T>::T##name(): TSort##rsort<T>(4, TRUE) {} \
\
\
template<class T> \
Sort              T##name<T>::GetDesiredChildSort(int n) \
{ \
	switch(n) { case 0:  return SORT_##a0sort; \
					case 1:  return SORT_##a1sort; \
					case 2:  return SORT_##a2sort; \
					case 3:  return SORT_##a3sort; \
					default: return SORT_NONE; \
	} \
}



#define DEFINE_OP5(name, rsort, a0name, a0sort, a1name, a1sort, a2name, a2sort, a3name, a3sort, a4name, a4sort)  \
template<class T> \
class		T##name:	 public TSort##rsort<T> { \
public: \
	Operator 				GetOperator() { return OP_##name; } \
	void                 Draw(TMyDC&, TPoint&); \
	void                 CalcSize(TMyDC&); \
\
	TSort##a0sort<T>*    Get##a0name()  { return (TSort##a0sort<T>*)GetChild(0); } \
	TSort##a1sort<T>*    Get##a1name()  { return (TSort##a1sort<T>*)GetChild(1); } \
	TSort##a2sort<T>*    Get##a2name()  { return (TSort##a2sort<T>*)GetChild(2); } \
	TSort##a3sort<T>*    Get##a3name()  { return (TSort##a3sort<T>*)GetChild(3); } \
	TSort##a4sort<T>*    Get##a4name()  { return (TSort##a4sort<T>*)GetChild(4); } \
	Sort                 GetDesiredChildSort(int n); \
	int                  GetDesiredNumChildren() { return 5; } \
\
								T##name(); \
}; \
template<class T> \
								T##name<T>::T##name(): TSort##rsort<T>(5, TRUE) {} \
\
\
template<class T> \
Sort              T##name<T>::GetDesiredChildSort(int n) \
{ \
	switch(n) { case 0:  return SORT_##a0sort; \
					case 1:  return SORT_##a1sort; \
					case 2:  return SORT_##a2sort; \
					case 3:  return SORT_##a3sort; \
					case 4:  return SORT_##a4sort; \
					default: return SORT_NONE; \
	} \
}





#define DEFINE_OP_LIST(name, rsort, aname, asort)  \
template<class T> \
class		T##name:	 public TSort##rsort<T> { \
public: \
	Operator 				GetOperator() { return OP_##name; } \
	void                 Draw(TMyDC&, TPoint&); \
	void                 CalcSize(TMyDC&); \
\
	TSort##asort<T>*     Get##aname(int n)  { return (TSort##asort<T>*)GetChild(n); } \
	Sort                 GetDesiredChildSort(int n) { return n>=0?SORT_##asort:SORT_NONE; } \
	BOOL                 IsList() { return TRUE; } \
\
								T##name(); \
};\
template<class T> \
								T##name<T>::T##name(): TSort##rsort<T>(0, FALSE) {} \
\


#define DEFINE_SORT(name)  \
const Sort SORT_##name = OP_##name##HOLE;\
template<class T> \
class		TSort##name: public T { \
public: \
	Sort  					GetSort() { return SORT_##name; } \
								TSort##name(int n = 0, int fixed = FALSE); \
};\
template<class T> \
								TSort##name<T>::TSort##name(int n, int fixed): T(n, fixed) {}

#define DEFINE_SORT_AND_HOLE(name)  \
DEFINE_SORT(name) \
DEFINE_OP0(name##HOLE,name)


// insert '#include "my signature module .h"' here!

#include "sign_pl4.h"

const			 MAXOPNAMELEN   = 20;
const			 MAXOPDATALEN   = 100;

char   		*GetSortName(Sort sort);
char   		*GetOpName(Operator op);
Sort      	 GetOpSort(Operator op);



class		TTerm: public TTreeNode {
public:
	inline				TTerm(int n = 0, int fixed = FALSE): TTreeNode(n, fixed),Data(0),Length(0) {}
						  ~TTerm();

	virtual Operator	GetOperator() = 0;
	inline char		  *GetOpName()   					{ return ::GetOpName(GetOperator()); }
	virtual int       GetDesiredNumChildren()    { return 0; }
	virtual BOOL      IsList()                   { return FALSE; }

	virtual Sort     	GetSort()      = 0;
	inline char		  *GetSortName() 					{ return ::GetSortName(GetSort()); }

	TTerm            *GetChild(int n) 				{ return (TTerm*)TTreeNode::GetChild(n);}
	virtual Sort      GetDesiredChildSort(int n) { return SORT_NONE; }

	void					SetData(void *data, int len);
	void				  *GetData()						{ return Data; }
	int					GetDataLength()				{ return Length; }

	int               GetTermLength();
	friend ostream&   operator<<(ostream&, TTerm *);
private:
	void				  *Data;
	int					Length;
};

void		AskData(TWindow *window, TTerm *node);

#endif

