//----------------------------------------------------------------------------
//    Copyright 1995 Hugo Lyppens
//   	Implements class TTree/TTreeNode
//----------------------------------------------------------------------------
#include "owlhdr.h"
#pragma hdrstop
#include "tree.h"


void TTreeNode::SetChildNumbers(int n)
{
	for(int i = n; i<Children.GetItemsInContainer(); i++) {
		Children[i]->MyChildNumber = i;
	}
}


long     TTreeNode::CountSubtreeNodes() const
{
   int   nc = GetNumChildren();
   int   nel = 1;

   for(int i = 0; i<nc; i++) {
      TTreeNode*  e = GetChild(i);
      if(e)
         nel += e->CountSubtreeNodes();
   }
   return nel;
}

BOOL		TTreeNode::IsDescendant(TTreeNode *anc) const
{
   const TTreeNode const  *p = this;
   while(p = p->GetParent()) {
      if(p == anc)
         return TRUE;
   }
   return FALSE;
}

void					DeleteTTreeNode(TTreeNode *e)
{
	delete e;
}


