class   TViewNode : public TTerm {
public:
								TViewNode(int n = 0, int fixed = FALSE);
	inline TViewNode    *GetChild(int n) const;
	inline TViewNode    *GetParent() const;

	inline BOOL          GetFolded() const;
	inline void          SetFolded(BOOL folded);
	inline TSize&        NodeSize();
	inline int	         NodeHeight() const;
	inline int	         NodeWidth() const;


	virtual void         Draw(TMyDC&, TPoint&) = 0;
	virtual void         CalcSize(TMyDC&)      = 0;

	void          			SetNodeSize(TSize& sz);
	void         			AddNodePosition(TPoint& pt);
	TPoint&					GetNodePosition(int n) const;
	int						GetNumNodePositions() const;

	void						FlushChildrenNodePositions();
	void						FlushNodePositions();
	TViewNode           *WhichNode(TPoint& point);
	BOOL                 IsVisible() const;
private:
	TSize                Size;
	BOOL                 Folded;
	TArrayAsVector<TPoint>	NodePositions;
};


inline TViewNode* TViewNode::GetChild(int n) const
{  return (TViewNode*)TTreeNode::GetChild(n);
}

inline TViewNode* TViewNode::GetParent() const
{  return (TViewNode*)Parent;
}

inline TSize&     TViewNode::NodeSize()
{  return Size; }
inline int      	TViewNode::NodeWidth() const
{  return Size.cx; }
inline int      	TViewNode::NodeHeight() const
{  return Size.cy; }
inline BOOL       TViewNode::GetFolded() const
{  return Folded; }
inline void       TViewNode::SetFolded(BOOL folded)
{  Folded = folded; }
inline void			TViewNode::FlushNodePositions()
{	NodePositions.Flush(); }
const long& max(const long&, const long&);
