
template<class T>
class   TViewTree: public TTree<T> {
public:
                         TViewTree(TTree<TTerm> *termtree);
   inline T             *GetFocus() const;
   inline void           SetFocus(T *);
   inline T             *WhichNode(TPoint& point) const;
	void                  CreateMirror(T *parent, int childnumber, TTerm *term);
private:
	T                    *Focus;
};

template<class T>                    TViewTree<T>::TViewTree(TTree<TTerm> *termtree)
{
	if(termtree->GetRoot())
		CreateMirror(0, 0, termtree->GetRoot());
	Focus = GetRoot();
}

template<class T>
void TViewTree<T>::CreateMirror(T *parent, int childnumber, TTerm *term)
{
   T  *node = CreateOperatorNode((T *)0, term->GetOperator());

	if(node) {
		node->SetData(term->GetData(), term->GetDataLength());
		if(childnumber < GetNumChildren(parent)) {
         ReplaceChild(parent, childnumber, node);
      } else if(childnumber == GetNumChildren(parent)) {
         AddChild(parent, node);
      }
		int nc = term->GetNumChildren();
      for(int i = 0; i<nc; i++) {
         CreateMirror(node, i, term->GetChild(i));
      }
	}
}

template<class T> inline T          *TViewTree<T>::GetFocus() const
{  return Focus;
}

template<class T> inline void        TViewTree<T>::SetFocus(T *newfocus)
{  Focus = newfocus;
}

template<class T> inline T          *TViewTree<T>::WhichNode(TPoint& point) const
{  return GetRoot()? (T *)GetRoot()->WhichNode(point):0;
}


